﻿using System;

namespace Books.Core.Services
{
    public class BooksService
        : IBooksService
    {
        private readonly ISimpleRestService simpleRestService;

        public BooksService(ISimpleRestService simpleRestService)
        {
            this.simpleRestService = simpleRestService;
        }

        public void StartSearchAsync(string whatFor, Action<BookSearchResult> success, Action<Exception> error)
        {
            string address = string.Format("https://www.googleapis.com/books/v1/volumes?q={0}",
                                            Uri.EscapeDataString(whatFor));
            simpleRestService.MakeRequest<BookSearchResult>(address,
                "GET", success, error);
        }
    }
}
