using System.Collections.Generic;
using System.ServiceModel.Channels;
using System.Windows.Input;
using Books.Core.Services;
using Cirrious.MvvmCross.ViewModels;

namespace Books.Core.ViewModels
{
    public class FirstViewModel
        : MvxViewModel
    {

        private readonly IBooksService booksService;

        public FirstViewModel(IBooksService booksService)
        {
            this.booksService = booksService;
            SearchCommand = new MvxCommand(update);
        }

        private string searchTerm;

        public string SearchTerm
        {
            get { return searchTerm; }
            set
            {
                searchTerm = value;
                RaisePropertyChanged(() => SearchTerm);
            }
        }

        private List<BookSearchItem> results;

        public List<BookSearchItem> Results
        {
            get { return results; }
            private set { results = value; RaisePropertyChanged(() => Results); }
        }

        private void update()
        {
            if (string.IsNullOrWhiteSpace(searchTerm)) return;
            booksService.StartSearchAsync(SearchTerm,
                result=>Results=result.items,
                                          ex => { });
        }

        public ICommand SearchCommand { get; private set; }
    }
}
